<chapter xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xi="http://www.w3.org/2001/XInclude" version="5.0" xml:lang="hu">
    <info>
        <title>Helló, Turing!</title>
        <keywordset>
            <keyword/>
        </keywordset>
    </info>
    <section>
        <title>Végtelen ciklus</title>
        <para>
            Írj olyan C végtelen ciklusokat, amelyek 0 illetve 100 százalékban dolgoztatnak egy magot és egy olyat, amely  
            100 százalékban minden magot!
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/lvmi6tyz-nI">https://youtu.be/lvmi6tyz-nI</link>
        </para>
	
	<para>
	Megoldás videóm: <link xlink:href="https://www.youtube.com/watch?v=xFn6oMLGSFo">https://www.youtube.com/watch?v=xFn6oMLGSFo</link>
	</para>

        <para>
            Megoldás forrása: <link xlink:href="Turing/infty-f.c">
                <filename>bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Turing/infty-f.c</filename>
            </link>, 
            <link xlink:href="Turing/infty-w.c">
                <filename>bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Turing/infty-w.c</filename>
            </link>.
        </para>
        <para>
            Számos módon hozhatunk és hozunk létre végtelen ciklusokat. 
            Vannak esetek, amikor ez a célunk, például egy szerverfolyamat fusson folyamatosan és van amikor egy
            bug, mert ott lesz végtelen ciklus, ahol nem akartunk. Saját péláinkban ilyen amikor a PageRank algoritmus
            rázza az 1 liter vizet az internetben, de az iteráció csak nem akar konvergálni...
        </para>                    
        <para>
            Egy mag 100 százalékban:               
        </para>
        <programlisting language="c"><![CDATA[int
main ()
{
  for (;;);

  return 0;
}
]]>
        </programlisting>        
        <para>        
        vagy az olvashatóbb, de a programozók és fordítók (szabványok) között kevésbé hordozható
        </para>

	<mediaobject>
		<imageobject>
			<imagedata fileref="img/vegtelencfor.png" scale="50" />
		</imageobject>
	</mediaobject>

        <programlisting language="c"><![CDATA[int
#include <stdbool.h>
main ()
{
  while(true);

  return 0;
}
]]>
        </programlisting>

	<mediaobject>
		<imageobject>
			<imagedata fileref="img/vegtelencwhile.png" scale="50" />
		</imageobject>
	</mediaobject>	
        
        <para>
            Azért érdemes a <literal>for(;;)</literal> hagyományos formát használni, 
            mert ez minden C szabvánnyal lefordul, másrészt
            a többi programozó azonnal látja, hogy az a végtelen ciklus szándékunk szerint végtelen és nem szoftverhiba. 
            Mert ugye, ha a <literal>while</literal>-al trükközünk egy nem triviális 
            <literal>1</literal> vagy <literal>true</literal> feltétellel, akkor ott egy másik, a forrást
            olvasó programozó nem látja azonnal a szándékunkat.
        </para>            
        <para>
            Egyébként a fordító a <literal>for</literal>-os és 
            <literal>while</literal>-os ciklusból ugyanazt az assembly kódot fordítja:
        </para>            
        <screen><![CDATA[$ gcc -S -o infty-f.S infty-f.c 
$ gcc -S -o infty-w.S infty-w.c 
$ diff infty-w.S infty-f.S 
1c1
< 	.file	"infty-w.c"
---
> 	.file	"infty-f.c"
]]></screen>  
        <para>
            Egy mag 0 százalékban:               
        </para>        
        <programlisting language="c"><![CDATA[#include <unistd.h>
int
main ()
{
  for (;;)
    sleep(1);
    
  return 0;
}
]]>
        </programlisting> 

	<mediaobject>
		<imageobject>
			<imagedata fileref="img/mag0.png" scale="50" />
		</imageobject>
	</mediaobject>
       
        <para>
            Minden mag 100 százalékban:               
        </para>

        <programlisting language="c"><![CDATA[#include <omp.h>
int
main ()
{
#pragma omp parallel
{
  for (;;);
}
  return 0;
}
]]>
        </programlisting>

	<mediaobject>
		<imageobject>
			<imagedata fileref="img/mag100.png" scale="50" />
		</imageobject>
	</mediaobject> 
        
        <para>
            A <command>gcc infty-f.c -o infty-f -fopenmp</command> parancssorral készítve a futtathatót, majd futtatva,               
            közben egy másik terminálban a <command>top</command> parancsot kiadva tanulmányozzuk, mennyi CPU-t használunk:            
        </para>
        <screen><![CDATA[top - 20:09:06 up  3:35,  1 user,  load average: 5,68, 2,91, 1,38
Tasks: 329 total,   2 running, 256 sleeping,   0 stopped,   1 zombie
%Cpu0 :100,0 us, 0,0 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
%Cpu1 : 99,7 us, 0,3 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
%Cpu2 :100,0 us, 0,0 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
%Cpu3 : 99,7 us, 0,3 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
%Cpu4 :100,0 us, 0,0 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
%Cpu5 :100,0 us, 0,0 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
%Cpu6 :100,0 us, 0,0 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
%Cpu7 :100,0 us, 0,0 sy, 0,0 ni, 0,0 id, 0,0 wa, 0,0 hi, 0,0 si, 0,0 st
KiB Mem :16373532 total,11701240 free, 2254256 used, 2418036 buff/cache
KiB Swap:16724988 total,16724988 free,       0 used. 13751608 avail Mem 

  PID USER      PR  NI    VIRT    RES    SHR S  %CPU %MEM     TIME+ COMMAND     
 5850 batfai    20   0   68360    932    836 R 798,3  0,0   8:14.23 infty-f     
]]></screen>  
                                
        <tip>
            <title>Werkfilm</title>
            <itemizedlist>
                <listitem>
                    <para>
                        <link xlink:href="https://youtu.be/lvmi6tyz-nI">https://youtu.be/lvmi6tyz-nI</link>
                    </para>    
                </listitem>                
            </itemizedlist>                
        </tip>
    </section>        
        
    <section>
        <title>Lefagyott, nem fagyott, akkor most mi van?</title>
        <para>
            Mutasd meg, hogy nem lehet olyan programot írni, amely bármely más programról eldönti, hogy le fog-e fagyni vagy sem!
        </para>
        <para>
            Megoldás videóm: Erről nem készíthető videó
        </para>
        <para>
            Megoldás forrása:  tegyük fel, hogy akkora haxorok vagyunk, hogy meg tudjuk írni a <function>Lefagy</function>
            függvényt, amely tetszőleges programról el tudja dönteni, hogy van-e benne vlgtelen ciklus:              
        </para>
        <programlisting language="c"><![CDATA[Program T100
{

	boolean Lefagy(Program P)
	{
		 if(P-ben van végtelen ciklus)
			return true;
		 else
			return false; 
	}

	main(Input Q)
	{
		Lefagy(Q)
	}
}]]></programlisting>            
        <para>
            A program futtatása, például akár az előző <filename>v.c</filename> ilyen pszeudókódjára:
            <screen><![CDATA[T100(t.c.pseudo)
true]]></screen>            
            akár önmagára
            <screen><![CDATA[T100(T100)
false]]></screen>  
            ezt a kimenetet adja.          
        </para>
        <para>
            A T100-as programot felhasználva készítsük most el az alábbi T1000-set, amelyben a
            Lefagy-ra épőlő Lefagy2 már nem tartalmaz feltételezett, csak csak konkrét kódot:
        </para>
        <programlisting language="c"><![CDATA[Program T1000
{

	boolean Lefagy(Program P)
	{
		 if(P-ben van végtelen ciklus)
			return true;
		 else
			return false; 
	}

	boolean Lefagy2(Program P)
	{
		 if(Lefagy(P))
			return true;
		 else
			for(;;); 
	}

	main(Input Q)
	{
		Lefagy2(Q)
	}

}]]></programlisting>            
        <programlisting><![CDATA[]]></programlisting>            
        <para>
            Mit for kiírni erre a <computeroutput>T1000(T1000)</computeroutput> futtatásra?
                                
            <itemizedlist>
                <listitem>
                    <para>Ha T1000 lefagyó, akkor nem fog lefagyni, kiírja, hogy true</para>                        
                </listitem>
                <listitem>
                    <para>Ha T1000 nem fagyó, akkor pedig le fog fagyni...</para>                        
                </listitem>
            </itemizedlist>
            akkor most hogy fog működni? Sehogy, mert ilyen <function>Lefagy</function>
            függvényt, azaz a T100 program nem is létezik.                
        </para>
        <para>
            A Lefagy függvény nem lehetséges, mert ha a program tartalmaz végtelen ciklust, akkor nem kapunk semmilyen eredményt, ezáltal nem tudjuk meg, hogy most végtelen ciklus vagy épp lefagyott vagy még dolgozik a program és azért nem ad semmi ”kézzel foghatót”.
        </para>
    </section>        
                
    <section>
        <title>Változók értékének felcserélése</title>
        <para>
            Írj olyan C programot, amely felcseréli két változó értékét, bármiféle logikai utasítás vagy kifejezés
            nasználata nélkül!
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://bhaxor.blog.hu/2018/08/28/10_begin_goto_20_avagy_elindulunk">https://bhaxor.blog.hu/2018/08/28/10_begin_goto_20_avagy_elindulunk</link>
        </para>
	<para>
	Megoldás videóm: <link xlink:href="https://www.youtube.com/watch?v=Z8Mlxvg5AOM">https://www.youtube.com/watch?v=Z8Mlxvg5AOM</link>
        </para>
        <para>
	A feladat megoldására több lehetőség is lehetséges, ha logikai utasításokat használunk. 
	I. Egy segéd változót vezetünk be:
	<programlisting language="c"><![CDATA[pluszvaltozo
	#include <stdlib.h>
	#include <stdio.h>
	int main() {
	int a, b, c; //c-->segédváltozó
	//Mivel a feladat nem szabja meg, hogy a két változó értéke honnan származzon így az egyszerűség kedvéért saját magunk adjuk meg az értéket
	a=6; b=4;
	printf(”Csere elött: a= %d b= %d”,a,b);
	c=a; //c= 6
	a=b; //a= 4
	b=c; //b= 6
	printf(”Csere után: a= %d b= %d”,a,b);
	return 0; }]]></programlisting>
	II. Műveletekkel, segédváltozó nélkül
	a/<programlisting language="c"><![CDATA[vatnelk1 
	#include <stdlib.h>
	#include <stdio.h>
	int main() {
	int a=6, b=4;
	//Mivel a feladat nem szabja meg, hogy a két változó értéke honnan származzon így az egyszerűség kedvéért saját magunk adjuk meg az értéket
	printf(”Csere elött: a= %d b= %d”,a,b);
	a=a+b; // a= 6+4 = 10
	b=a-b; // b= 10-4 = 6
	a=a-b; // a= 10-6 = 4
	printf(”Csere után: a= %d b= %d”,a,b);
	return 0; } 
	]]></programlisting>
	

	b/<programlisting language="c"><![CDATA[vatnelk2
	#include <stdlib.h>
	#include <stdio.h>
	int main() {
	int a=6, b=4;
	//Mivel a feladat nem szabja meg, hogy a két változó értéke honnan származzon így az egyszerűség kedvéért saját magunk adjuk meg az értéket
	printf(”Csere elött: a= %d b= %d”,a,b);
	a=a-b; //a= 6-4 = 2
	b=a+b; //b=2+4 = 6
	a=b-a; //a= 6-2 = 4
	printf(”Csere után: a= %d b= %d”,a,b);
	return 0; }
	]]></programlisting>

	III. XOR
	<programlisting language="c"><![CDATA[XOR
	#include <stdlib.h>
	#include <stdio.h>
	int main() {
	int a=10, b=5; //a= 1010, b= 0101
	//Mivel a feladat nem szabja meg, hogy a két változó értéke honnan származzon így az egyszerűség kedvéért saját magunk adjuk meg az értéket
	printf(”Csere elött: a= %d b= %d”,a,b);
	//XOR --> ^
	a=a^b; // a= 1111 (15)
	b=a^b; // b= 1010 (10)
	a=a^b; // a= 0101 (5)
	printf(”Csereután: a= %d b= %d”,a,b);
	return 0; }
	]]></programlisting>
	Bitenkénti kizáró vagy (XOR) művelet fő felhasználási területe a titkosítás. A működése a következő: ha az egyes bitek értéke azonos akkor az eredmény 0, és ha a bitek értéke különböző akkor az eredmény bitje 1-s lesz.

	</para>
    </section>                     

    <section>
        <title>Labdapattogás</title>
        <para>
            Először if-ekkel, majd bármiféle logikai utasítás vagy kifejezés
            nasználata nélkül írj egy olyan programot, ami egy labdát pattogtat a karakteres konzolon! (Hogy mit értek
            pattogtatás alatt, alább láthatod a videókon.)
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://bhaxor.blog.hu/2018/08/28/labdapattogas">https://bhaxor.blog.hu/2018/08/28/labdapattogas</link>
        </para>
	<para>
            Megoldás videóm: <link xlink:href="https://www.youtube.com/watch?v=mMVf972lcsY">https://www.youtube.com/watch?v=mMVf972lcsY</link>
        </para>
        <para>
            Megoldás forrása:  
        </para>
        <para>
            IF-EL:
		<programlisting language="c"><![CDATA[ifel
		#include <stdio.h>
		#include <curses.h>
		#include <unistd.h>

		int main(){
		WINDOW *terem;
		terem = initscr();
		int x = 0, y = 0;
		int maxx, maxy, novelox=1, noveloy=1;
		for ( ; ; ) {
		getmaxyx(terem, maxy , maxx );
		mvwprintw(terem, y, x, "O");
		refresh ();
		usleep (100000);
		clear(); //Hogy csak a "labdát" lássuk, a menetét ne
		//Meredekség beállítása
		x += novelox;
		y += noveloy;
		//Képből való kimenés megakadályozása
		//Lenti vagy fenti kimentés megakadályozása
		if (y>=maxy-1 || y<=0) {
                	noveloy= noveloy * - 1;
		}
		//Jobb vagy bal oldali kimenés megakadályozása
		if(x>=maxx-1 || x<=0) {
               		novelox= novelox * - 1;
		}
		}
		return 0;
		}]]></programlisting>
	Kezdjük a program elejéről. Az #include curses.h azért szükséges hogy az aktuális parancssorunkról 	adatokat kérhessünk késöbb ezért kellenek majd a maxx, maxy változók.
DE a WINDOW...Először is ez egy alap osztálya a programkörnyezetnek. Valaki ezt egyszer megírta és mi használjuk. Röviden csak annyi hogy egy osztály tulajdonságokkal van felruházva pl: EMBER--> van keze, lába, füle ezekből jobb és bal, stb. Ugyanígy a WINDOW-nak van szélessége, magassága, stb. de most nekünk ezek a legfontosabbak.
	WINDOW osztály alapján létrehoztunk egy termet, ha már labdapattogtatás, az legyen egy ”termben”.
	Az initsrc() a WINDOW szintén egy ”tulajdonsága”. Általában az első rutin. Az initscr() meghatározza a terminál típusát és inicializálja az összes tulajdonságát az ablakunknak. Majd a hívását követően teljesen letörli a képernyőt.

	Programunnkhoz egy végtelenciklust használunk ami most a for( ; ; ) lesz.
	A getmaxyx(WINDOW *win,int y, int x) az adott ablak aktuális kurzorpozícióját az y és x változókba helyezi. Esetünkben ezek az ablak maximális szélességi és magassági értékei lesznek eltárolva.
	Következő eleme a kódunknak szinte a legfontosabb. Az mvwprintw(WINDOW *win, int y, int x, const char *fmt,...), működéséhez kell az #include curses.h. Voltaképpen ezzel rajzoljuk ki a labdát a képernyőre. A printf-hez hasonló, csak itt megadjuk neki, hogy melyik ablakban és hogy azon belül hova rajzoljon és mit.
	A refresh() mindig frissíti a tényleges kimenetet. Ezt lehetne variálni, hogy wrefresh(WINDOW *win)-t használunk, hogy a megadott ablak tartalmát frissítse. DE a programunk így is működik, ha nem wrefresh()-t használunk csak sima refresh()-t;.
	A usleep() felfüggeszti a hívó szál végrehajtását a megadott mikroszekundumokig. Esetünkben a ”labda” gyorsaságát tudjuk szabályozni vele. Működéséhez kell az #include unistd.h.
	Az if-ben fellelhető a || szimbólum. Ez a programozásban a ”vagy” operátor.

	Javasolt feltenni a következő page-t mert ez nem alap:
		sudo apt-get install libncurses5-dev
	Valamint fordításnál javasolt a következőképpen eljárni:
		g++ vagy gcc prognev.c vagy .cpp –o prognev –lncurses
	Futtatni pedig a következőképpen lehet a fordítás után:
		./prognev
	Leállítani a programot a Ctrl+C-vel lehet

	IF NÉLKÜL
	<programlisting language="c"><![CDATA[ifnelkul
		#include <stdio.h>
		#include <stdlib.h>
		#include <unistd.h>
		#include <math.h>

		#define SZELESSEG 78 //ablak szélessége
		#define MAGASSAG 22 //ablak magassága

		int kordinataMeghatarozo(int y, int x){
		int i;
		for(i=0;i<y;i++) printf("\n"); //Magassági kordináta
		for(i=0;i<x;i++) printf(" "); //Szélességi kordináta
		printf("O\n"); //Labdánk kirajzolása
		return 0;
		}

		int main() {
		int x=0, y=0;
		while(1){
		system("clear"); //Képernyő törlése két kirajzolás között
		//Labda kordinátáit számolja ki, majd kirajzolja
		kordinataMeghatarozo(abs(MAGASSAG-(y++%(MAGASSAG*2))),abs(SZELESSEG-(x++%(SZELESSEG*2))));
		usleep(100000);
		}
		return 0;
		}]]></programlisting>
	Kezdjük megint a program elejéről. Az #include stdio.h a printf()-hez kell majd. Az #include stdlib.h szükség lesz az abs függvény használatához. És amit még nem néztünk meg az #include math.h könyvtár amivel matematikai számításokat tudunk elvégezni, szintén az abs felhasználásához lesz szükségünk rá.
	Következő elemeink a #define SZELESSEG és MAGASSAG melyekkel az ablak méretét fogjuk szabályozni (a 78 és a 22 értékeket lehet változtatni), amik fixek maradnak.
	A kordinataMeghatarozo függvényünknek kordinátákat kell megadni és ezen kordináták alapján fogja kirajzolni a program a labdánkat. A labda folyamatosságát a for ciklus szabályozza, hogy ne össze vissza menjen a labdánk.
	A main-ben a végtelen ciklusunk most egy while lett. Mivel a függvényünk mindig 0-t fog visszaadni és a while addíg megy míg 1-es nem lesz ezért Ctrl+C megszakításig fut a program.
	Az abs függvényt azért használjuk a programunkban, hogy ne kapjon a megírt függvényünk negatív kordinátát. Ha negatív kordinátát kapna a függvényünk, akkor azt az ablakon esetünkben a teremen kívül esne, így nem látnánk.
	A % maradékos osztást végez el és a maradékot adja vissza és ezzel az értékkel számolunk tovább.
        </para>
    </section>                     

    <section>
        <title>Helló, Google!</title>
        <para>
            Írj olyan C programot, amely egy 4 honlapból álló hálózatra kiszámolja a négy lap Page-Rank 
            értékét!
        </para>
        <para>
            Megoldás videó: <link xlink:href=""></link>
        </para>
	<para>
            Megoldás videóm: <link xlink:href="https://www.youtube.com/watch?v=2anZl59wNyg">https://www.youtube.com/watch?v=2anZl59wNyg</link>
        </para>
        <para>
            Megoldás forrása: <link xlink:href="https://progpater.blog.hu/2011/02/13/bearazzuk_a_masodik_labort"></link>
        </para>
        <para>
            A feladat neve kapcsán kezdjük azzal, hogy mégis miért ez. Még a Google alapítói fejlesztették ki ezt, amit végül is PageRank-nak nevezünk. Lényegében azt jelenti hogy egy weboldalhoz egy értéket számol ami úgy adódik, hogyha minél több oldal mutat rá azaz használja a linkjét, annál jobb lesz az eredménye annak a weboldalnak. De ha minél több link mutat ki az adott weboldalból annál rosszabb ez az érték. Ugye bár pedig a google azt adja fel első keresési találatnak amelyik weboldalnak a legjobb a PageRankból kiadódó értéke.
        </para>
	
	<para>De nézzük is kódban 4 oldalra:</para>

	<programlisting language="c"><![CDATA[hellogoogle
	#include <stdio.h>
	#include <math.h>

	void kiir (double tomb[], int db) {
		for (int i = 0; i < db; ++i)
		printf("PageRank [%d]: %lf\n", i, tomb[i]);
	}

	double tavolsag (double PR[], double PRv[], int n) {
		double osszeg = 0.0;
		for (int i = 0; i < n; ++i)
		osszeg += (PRv[i] - PR[i]) * (PRv[i] - PR[i]);
		return sqrt(osszeg);
		//Negatív érték elkerülése végett szorzunk és vonunk gyököt
	}

	int main (void) {

		double L[4][4] = {
			{0.0, 0.0, 1.0 / 3.0, 0.0},
			{1.0, 1.0 / 2.0, 1.0 / 3.0, 1.0},
			{0.0, 1.0 / 2.0, 0.0, 0.0},
			{0.0, 0.0, 1.0 / 3.0, 0.0}
		};

		double PR[4] = { 0.0, 0.0, 0.0, 0.0 }; //Maga a PageRank, ez lesz a végleges
		double PRv[4] = { 1.0 / 4.0, 1.0 / 4.0, 1.0 / 4.0, 1.0 / 4.0 }; //Ideiglenes PageRank

		int i, j;
		for (;;) {
			for (i = 0; i < 4; ++i) {
				PR[i] = 0.0;
				for (j = 0; j < 4; ++j)
					PR[i] += (L[i][j] * PRv[j]);
			}
			if (tavolsag (PR, PRv, 4) < 0.00000001)
				break; //Ha elég kicsi akkor megállunk, mert pontos eredményt kapunk
				//Ha viszont túl nagy értéket kapunk, akkor frissítjük a PRv-t és kezdünk minden számolást előlről			
			for (i = 0; i < 4; ++i)
			PRv[i] = PR[i];
		}

		kiir (PR, 4);
		return 0;
	}
	]]></programlisting>
	
	<para>Fordításhoz használjuk a -lm-et: 
	pl:	gcc hellogoogle.c -o hellogoogle -lm</para>
	
	<mediaobject>
		<imageobject>
			<imagedata fileref="img/hellogoogle.png" scale="50" />
		</imageobject>
	</mediaobject>

    </section>
                                                                                                                                                                                                                                                                                                                                                        
    <section xml:id="bhax-textbook-feladatok-turing.MontyHall">
        <title>A Monty Hall probléma</title>
        <para>
            Írj R szimulációt a Monty Hall problémára!
        </para>

	<para>
            Megoldás videóm: <link xlink:href="https://youtu.be/bnDW16UYRcA">https://youtu.be/bnDW16UYRcA</link>
        </para>

        <para>
            Megoldás videó: <link xlink:href="https://bhaxor.blog.hu/2019/01/03/erdos_pal_mit_keresett_a_nagykonyvben_a_monty_hall-paradoxon_kapcsan">https://bhaxor.blog.hu/2019/01/03/erdos_pal_mit_keresett_a_nagykonyvben_a_monty_hall-paradoxon_kapcsan</link>
        </para>
        <para>
            Megoldás forrása: <link xlink:href="https://gitlab.com/nbatfai/bhax/tree/master/attention_raising/MontyHall_R">https://gitlab.com/nbatfai/bhax/tree/master/attention_raising/MontyHall_R</link>
        </para>
	<para>
            Megoldás forrása: <link xlink:href="https://betterexplained.com/articles/understanding-the-monty-hall-problem/?fbclid=IwAR0paVXk2MLkOzvr5HAJO0rjnZKJJ1pFOkXx8leRxWni3-q-yhJFAnyN8pY">https://betterexplained.com/articles/understanding-the-monty-hall-problem/?fbclid=IwAR0paVXk2MLkOzvr5HAJO0rjnZKJJ1pFOkXx8leRxWni3-q-yhJFAnyN8pY</link>
        </para>
	
	<para>
		Ez a "probléma" még egy régi televíziós műsorban jött fel ami egy nyereményjáték volt. A játékos kiválaszt egy ajtót, amásik kettő küzül pedig a műsorvezető kinyit egyet, ami mögött nincsen semmi, ezután a játékosoknak lehetősége van megváltoztatni a döntéstét.
	</para>
	<para>
		Az emberek úgy gondolják, hogy 50-50%esély van ha megváltoztatjuk a döntésünket vagy sem. Marilyn pedig ezt megcáfolta és be is bizonyította ha változtatunk a döntésünkön valóban megduplázzuk a nyerési esélyünket. Marilyn ellen mindenki azzal volt hogy ez hazugság, de számítógépes szimulációjával sikerült meggyőznie az embereket, hogy igen is igaza van. Így 2:1 arányban volt jó döntés, ha változatunk a döntésünkön.
	</para>

	<mediaobject>
		<imageobject>
			<imagedata fileref="img/montykep2.png" scale="50" />
		</imageobject>
	</mediaobject>

	<programlisting language="r"><![CDATA[
            kiserletek_szama=10000000
		kiserlet = sample(1:3, kiserletek_szama, replace=T)
		jatekos = sample(1:3, kiserletek_szama, replace=T)
		musorvezeto=vector(length = kiserletek_szama)

		for (i in 1:kiserletek_szama) {

		    if(kiserlet[i]==jatekos[i]){
		    
			mibol=setdiff(c(1,2,3), kiserlet[i])
		    
		    }else{
		    
			mibol=setdiff(c(1,2,3), c(kiserlet[i], jatekos[i]))
		    
		    }

		    musorvezeto[i] = mibol[sample(1:length(mibol),1)]

		}

		nemvaltoztatesnyer= which(kiserlet==jatekos)
		valtoztat=vector(length = kiserletek_szama)

		for (i in 1:kiserletek_szama) {

		    holvalt = setdiff(c(1,2,3), c(musorvezeto[i], jatekos[i]))
		    valtoztat[i] = holvalt[sample(1:length(holvalt),1)]
		    
		}

		valtoztatesnyer = which(kiserlet==valtoztat)


		sprintf("Kiserletek szama: %i", kiserletek_szama)
		length(nemvaltoztatesnyer)
		length(valtoztatesnyer)
		length(nemvaltoztatesnyer)/length(valtoztatesnyer)
		length(nemvaltoztatesnyer)+length(valtoztatesnyer)
	]]></programlisting>
	

	<mediaobject>
		<imageobject>
			<imagedata fileref="img/montykep.png" scale="80" />
		</imageobject>
	</mediaobject>

	<mediaobject>
		<imageobject>
			<imagedata fileref="img/montykep3.png" scale="50" />
		</imageobject>
	</mediaobject>
    </section>

    <section xml:id="Brun">
        <title>100 éves a Brun tétel</title>
        <para>
            Írj R szimulációt a Brun tétel demonstrálására!
        </para>

	<para>
            Megoldás videóm: <link xlink:href=""></link>
        </para>

        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/xbYhp9G6VqQ">https://youtu.be/xbYhp9G6VqQ</link>
        </para>
        <para>
            Megoldás forrása: <link xlink:href="https://gitlab.com/nbatfai/bhax/blob/master/attention_raising/Primek_R">https://gitlab.com/nbatfai/bhax/blob/master/attention_raising/Primek_R</link>
        </para>

        <para>
            A természetes számok építőelemei a prímszámok. Abban az értelemben, 
            hogy minden természetes szám előállítható prímszámok szorzataként.
            Például 12=2*2*3, vagy például 33=3*11.
        </para>
        <para>
            Prímszám az a természetes szám, amely csak önmagával és eggyel 
            osztható. Eukleidész görög matematikus már Krisztus előtt tudta, 
            hogy végtelen sok prímszám van, de ma sem tudja senki, hogy 
            végtelen sok ikerprím van-e. Két prím ikerprím, ha különbségük 2.
        </para>
        <para>
            Két egymást követő páratlan prím között a legkisebb távolság a 2, 
            a legnagyobb távolság viszont bármilyen nagy lehet! Ez utóbbit 
            könnyű bebizonyítani. Legyen n egy tetszőlegesen nagy szám. 
            Akkor szorozzuk össze n+1-ig a számokat, azaz számoljuk ki az 
            1*2*3*… *(n-1)*n*(n+1) szorzatot, aminek a neve (n+1) faktoriális, 
            jele (n+1)!.
        </para>
        <para>
            Majd vizsgáljuk meg az a sorozatot:
        </para>    
        <para>
            (n+1)!+2, (n+1)!+3,… , (n+1)!+n, (n+1)!+ (n+1) ez n db egymást követő azám, ezekre (a jól ismert
            bizonyítás szerint) rendre igaz, hogy            
        </para>    
        <itemizedlist>
            <listitem>
                <para>(n+1)!+2=1*2*3*… *(n-1)*n*(n+1)+2, azaz 2*valamennyi+2, 2 többszöröse, így ami osztható kettővel</para>
            </listitem>
            <listitem>
                <para>(n+1)!+3=1*2*3*… *(n-1)*n*(n+1)+3, azaz 3*valamennyi+3, ami osztható hárommal</para>
            </listitem>
            <listitem>
                <para>...</para>
            </listitem>
            <listitem>
                <para>(n+1)!+(n-1)=1*2*3*… *(n-1)*n*(n+1)+(n-1), azaz (n-1)*valamennyi+(n-1), ami osztható (n-1)-el</para>
            </listitem>
            <listitem>
                <para>(n+1)!+n=1*2*3*… *(n-1)*n*(n+1)+n, azaz n*valamennyi+n-, ami osztható n-el</para>
            </listitem>
            <listitem>
                <para>(n+1)!+(n+1)=1*2*3*… *(n-1)*n*(n+1)+(n-1), azaz (n+1)*valamennyi+(n+1), ami osztható (n+1)-el</para>
            </listitem>
        </itemizedlist>
        <para>
            tehát ebben a sorozatban egy prim nincs, akkor a (n+1)!+2-nél 
            kisebb első prim és a (n+1)!+ (n+1)-nél nagyobb első 
            prim között a távolság legalább n.            
        </para>    
        <para>
            Az ikerprímszám sejtés azzal foglalkozik, amikor a prímek közötti 
            távolság 2. Azt mondja, hogy az egymástól 2 távolságra lévő prímek
            végtelen sokan vannak.
        </para>    
        <para>
            A Brun tétel azt mondja, hogy az ikerprímszámok reciprokaiból képzett sor összege, azaz
            a (1/3+1/5)+ (1/5+1/7)+ (1/11+1/13)+... véges vagy végtelen sor konvergens, ami azt jelenti, hogy ezek
            a törtek összeadva egy határt adnak ki pontosan vagy azt át nem lépve növekednek, 
            ami határ számot B<subscript>2</subscript> Brun konstansnak neveznek. Tehát ez
            nem dönti el a több ezer éve nyitott kérdést, hogy az ikerprímszámok halmaza végtelen-e? 
            Hiszen ha véges sok van és ezek
            reciprokait összeadjuk, akkor ugyanúgy nem lépjük át a B<subscript>2</subscript> Brun konstans értékét, 
            mintha végtelen 
            sok lenne, de ezek már csak olyan csökkenő mértékben járulnának hozzá a végtelen sor összegéhez, 
            hogy így sem lépnék át a Brun konstans értékét.     
        </para>
        <para>
            Ebben a példában egy olyan programot készítettünk, amely közelíteni próbálja a Brun konstans értékét.
            A repó <link xlink:href="../../../bhax/attention_raising/Primek_R/stp.r">
                <filename>bhax/attention_raising/Primek_R/stp.r</filename>
            </link> mevű állománya kiszámolja az ikerprímeket, összegzi
            a reciprokaikat és vizualizálja a kapott részeredményt.
        </para>
        <programlisting language="R">
<![CDATA[#   Copyright (C) 2019  Dr. Norbert Bátfai, nbatfai@gmail.com
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>

library(matlab)

stp <- function(x){

    primes = primes(x)
    diff = primes[2:length(primes)]-primes[1:length(primes)-1]
    idx = which(diff==2)
    t1primes = primes[idx]
    t2primes = primes[idx]+2
    rt1plust2 = 1/t1primes+1/t2primes
    return(sum(rt1plust2))
}

x=seq(13, 1000000, by=10000)
y=sapply(x, FUN = stp)
plot(x,y,type="b")
]]>
        </programlisting>        
        <para>
            Soronként értelemezzük ezt a programot:
        </para>                
        <programlisting language="R">
<![CDATA[ primes = primes(13)]]>
        </programlisting>        
        <para>
            Kiszámolja a megadott számig a prímeket.             
        </para>
        <screen>
<![CDATA[> primes=primes(13)
> primes
[1]  2  3  5  7 11 13
]]>
        </screen>
                
        <programlisting language="R">
<![CDATA[ diff = primes[2:length(primes)]-primes[1:length(primes)-1]]]>
        </programlisting>        
        <screen>
<![CDATA[> diff = primes[2:length(primes)]-primes[1:length(primes)-1]
> diff
[1] 1 2 2 4 2
]]>
        </screen>        
        <para>
            Az egymást követő prímek különbségét képzi, tehát 3-2, 5-3, 7-5, 11-7, 13-11.
        </para>
        <programlisting language="R">
<![CDATA[idx = which(diff==2)]]>
        </programlisting>        
        <screen>
<![CDATA[> idx = which(diff==2)
> idx
[1] 2 3 5
]]>
        </screen>              
        <para>
            Megnézi a <varname>diff</varname>-ben, hogy melyiknél lett kettő az eredmény, mert azok az ikerprím párok, ahol ez igaz.
            Ez a <varname>diff</varname>-ben lévő 3-2, 5-3, 7-5, 11-7, 13-11 külünbségek közül ez a 2., 3. és 5. indexűre teljesül.
        </para>
        <programlisting language="R">
<![CDATA[t1primes = primes[idx]]]>
        </programlisting>  
        <para>
            Kivette a primes-ból a párok első tagját. 
        </para>
        <programlisting language="R">
<![CDATA[t2primes = primes[idx]+2]]>
        </programlisting>        
        <para>
            A párok második tagját az első tagok kettő hozzáadásával képezzük.
        </para>
        <programlisting language="R">
<![CDATA[rt1plust2 = 1/t1primes+1/t2primes]]>
        </programlisting>        
        <para>
            Az 1/t1primes a t1primes 3,5,11 értékéből az alábbi reciprokokat képzi:
        </para>
        <screen>
<![CDATA[> 1/t1primes
[1] 0.33333333 0.20000000 0.09090909
]]>
        </screen>                      
        <para>
            Az 1/t2primes a t2primes 5,7,13 értékéből az alábbi reciprokokat képzi:
        </para>
        <screen>
<![CDATA[> 1/t2primes
[1] 0.20000000 0.14285714 0.07692308
]]>
        </screen>                      
        <para>
            Az 1/t1primes + 1/t2primes pedig ezeket a törteket rendre összeadja.
        </para>
        <screen>
<![CDATA[> 1/t1primes+1/t2primes
[1] 0.5333333 0.3428571 0.1678322
]]>
        </screen>                      
        <para>
            Nincs más dolgunk, mint ezeket a törteket összeadni a 
            <function>sum</function> függvénnyel.
        </para>
        
        <programlisting language="R">
<![CDATA[sum(rt1plust2)]]>
        </programlisting>    
        <screen>
<![CDATA[>   sum(rt1plust2)
[1] 1.044023
]]>
        </screen>            
        <para>
            A következő ábra azt mutatja, hogy a szumma értéke, hogyan nő, egy határértékhez tart, a 
            B<subscript>2</subscript> Brun konstanshoz. Ezt ezzel a csipettel rajzoltuk ki, ahol először a fenti 
            számítást 13-ig végezzük, majd 10013, majd 20013-ig, egészen 990013-ig, azaz közel 1 millióig.
            Vegyük észre, hogy az ábra első köre, a 13 értékhez tartozó 1.044023.
        </para>
        <programlisting language="R">
<![CDATA[x=seq(13, 1000000, by=10000)
y=sapply(x, FUN = stp)
plot(x,y,type="b")]]>
        </programlisting>          
        <figure>
            <title>A B<subscript>2</subscript> konstans közelítése</title>
            <mediaobject>
                <imageobject>
                    <imagedata fileref="img/BrunKorok.png" scale="50" />
                </imageobject>
                <textobject>
                    <phrase>A B<subscript>2</subscript> konstans közelítése</phrase>
                </textobject>
            </mediaobject>
        </figure>                             
        <tip>
            <title>Werkfilm</title>
            <itemizedlist>
                <listitem>
                    <para>
                        <link xlink:href="https://youtu.be/VkMFrgBhN1g">https://youtu.be/VkMFrgBhN1g</link>
                    </para>    
                </listitem>                
                <listitem>
                    <para>
                        <link xlink:href="https://youtu.be/aF4YK6mBwf4">https://youtu.be/aF4YK6mBwf4</link>
                    </para>    
                </listitem>                
            </itemizedlist>                
        </tip>
	
	<para>Véleményem szerint ez a feladat már bőven ki van fejtve ezért nem részletezném tovább.</para>

	<mediaobject>
		<imageobject>
			<imagedata fileref="img/bruntetel.png" scale="50" />
		</imageobject>
	</mediaobject>

    </section>

    <section>
        <title>Vörös Pipacs Pokol/csiga folytonos mozgási parancsokkal</title>
        <para>
            Megoldás videóm (python): <link xlink:href="https://youtu.be/mYaB_aDg1XM">https://youtu.be/mYaB_aDg1XM</link>      
        </para>

        <para>
            Megoldás videóm (c++): <link xlink:href=" https://youtu.be/z5BednUcwe0"> https://youtu.be/z5BednUcwe0</link>      
        </para>

        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/uA6RHzXH840">https://youtu.be/uA6RHzXH840</link>      
        </para>
        <para>
            Megoldás forrása: <link xlink:href="https://github.com/nbatfai/RedFlowerHell">https://github.com/nbatfai/RedFlowerHell</link>               
        </para>

	<para>Változatott kódrészlet (python): </para>

	<programlisting language="python"><![CDATA[
	    def run(self):
		world_state = self.agent_host.getWorldState()
		# Loop until mission ends:
		i = 2
		while world_state.is_mission_running:
		    print("--- nb4tf4i arena ---\n")
		    for j in range(4):
		        self.agent_host.sendCommand( "move 1" )
		        time.sleep(i)            
		        self.agent_host.sendCommand( "turn 0.5" )
		        time.sleep(1)
		        self.agent_host.sendCommand( "turn 0" )
		    self.agent_host.sendCommand( "move 1" )
		    time.sleep(i)
		    self.agent_host.sendCommand( "jump 1" )
		    time.sleep(0.5)
		    self.agent_host.sendCommand( "jump 0" )
		    i = i + 1
		    world_state = self.agent_host.getWorldState()
	]]></programlisting>

	<para>Változatott kódrészlet (c++): </para>

	<programlisting language="c++"><![CDATA[
	    // main loop:
	    do {
		agent_host.sendCommand("move 1");
		boost::this_thread::sleep(boost::posix_time::milliseconds(500));
		agent_host.sendCommand("turn 1");
		boost::this_thread::sleep(boost::posix_time::milliseconds(500));

		world_state = agent_host.getWorldState();
		for( boost::shared_ptr<TimestampedString> error : world_state.errors )
		    cout << "Error: " << error->text << endl;
	    } while (world_state.is_mission_running);
	]]></programlisting>
            
    </section>        

</chapter>                
